
class Agent007 {
    public static final int nofAgents = 7;

    static class State {
        int[] agents = new int[nofAgents];

        State (int[] agents) {
            for (int i=0; i<nofAgents; i++) {
                this.agents[i] = agents[i];
            }
        }
    }


    public static void main (String args[]) throws Exception {
        int[] agents = { 4, 5, 6, 0, 1, 2, 3};
        checkAndPrint (agents);
    }

    public static void checkAndPrint(int[] agents1) throws Exception {
        int[] agents = new int[nofAgents];

        for (int i=0; i<nofAgents; i++) {
            agents[i] = agents1[i];
        }  

        State s = new State (agents);

        for (int i=0; i<nofAgents; i++) {
            if (  iAgent(s, iAgent(s, i)) != next(i)) throw new Exception();
        }
        
        for (int i=0; i<nofAgents; i++) {
            System.out.println( "The agent 00" + (i+1)  +
                                " watches the agent 00" +
                                (s.agents[i] +1) );
        }
    }

    public static int iAgent(State s, int ia) throws Exception {

        for (int i=0; i<nofAgents; i++) {
            if (s.agents[ia]==i) {s.agents[ia]=i; return i;}
        }

        throw new Exception();
    }
   
    public static int next(int iAgent) {
        if(iAgent==nofAgents-1) return 0;
          else return iAgent+1;
    }

}